using NLOptControl

# =========== PROBLEM DEFINITION ==============================
# Constraints on states
XL   = [..., ...]
XU   = [..., ...]
# Constraints on control
CL   = [NaN] # NaN means no Constraints
CU   = [NaN] # NaN means no Constraints
# Initial and final constraints on states
X0   = [..., ...]
XF   = [..., ...] # Use NaN to indicate no constraint

# Create problem =======================================================================
prob  = define(numStates = 2, numControls=1, X0=X0, XF=XF, CL=CL, CU=CU, XL=XL, XU=XU)
# Give name to states and controls
states!(prob, [:x1, :x2], descriptions=["x1(t)", "x2(t)"])
controls!(prob, [:u], descriptions=["u"])

# Setup model equations as julia **expressions** =======================================
dx    = Array{Expr}(2) # :( something ) means "build expression"
dx[1] = :( ... ) # ENTER EQUATIONS HERE, variable names are defined above
dx[2] = :( ... ) # ENTER EQUATIONS HERE

## Add dynamics to model =============================================================
dynamics!(prob, dx)
