using Ipopt         # Solver
using NLOptControl  # Problem definition and discretization
using PrettyPlots   # Plots for optimization problem
using Plots         # Custom plots

include("Vanderpol.jl")
# The problem is now defined as "prob"

# Control constraints
expr1 = :( ... <= ... <= ... )
constraints!(prob, [expr1])

# Number of grid points in discretization
N = 700
# Final time fixed, backward Euler discretization
configure!(prob; finalTimeDV=false, tf=10.0, integrationScheme=:bkwEuler, N=N)

# Set objective
obj = integrate!(prob, :( ... ) )
# Set to minimize obj
@NLobjective(prob.ocp.mdl, Min, obj)
# Or minimize time
#@NLobjective(prob.ocp.mdl, Min, prob.ocp.tf)

@time optimize!(prob)

#allPlots(prob)

data = prob.r.ocp.dfs[1]

plot(data[:t], data[:u], lab="u")
plot!(data[:t], data[:x1], lab="x1")
plot!(data[:t], data[:x2], lab="x2")
gui()
